//
//    File: image.h
//
//    (C) 2000-2008 Helmut Cantzler
//
//    Licensed under the terms of the Lesser General Public License.
//

#ifndef _IMAGE_H
#define _IMAGE_H

#define MAX_WIDTH 4048
#define MAX_HEIGHT 4048

#include <stdio.h>
#include "array3d.h"

class Image
{
public:
  Image();
  ~Image();

  int read(const char *filename);
  void greyToRGB(void);
  void scale(int height, int width);

  int height(void) const;
  int width(void) const;
  int pixelSize(void) const;

  const unsigned char* data(void);

private:
  Array3D<unsigned char> *imageData, *newData;
  int imageHeight, imageWidth, imagePixelSize;
};

#endif
